/*
 * EventList.h
 *
 *  Created on: Mar 19, 2012
 *      Author: nicolaq
 */

#ifndef EVENTLIST_H_
#define EVENTLIST_H_

#include"Event.h"
#include "Includes.h"

#ifndef CACHEDLIST_OPT

template<unsigned N>
class EventList {
public:
	EventList();
	~EventList();

	void insert(
			const pair<double, array<unsigned char, N>>& pEvent);
	uint64_t size() const;
	void setMark(uint64_t pIndex);
	void clearMark(uint64_t pIndex);
	bool isMarked(uint64_t pIndex) const;
	Event<N> getEvent(uint64_t pIndex) const;
	uint64_t memSize() const;
	uint64_t diskSize() const;
protected:
	vector<pair<double, array<unsigned char, N>>> mEventMemory;
	vector<bool> mUsed;
};

#include"EventListRamDefs.h"

#else

#include<iostream>
#include<fstream>
#include<sstream>
#include<stdio.h>
#include<unordered_map>

#include"EventList.h"

template<unsigned N>
class EventList {
public:
	EventList();
	virtual ~EventList();

	void insert(const pair<double, array<unsigned char, N>>& pEvent);
	uint64_t size() const;
	void setMark(uint64_t pIndex);
	void clearMark(uint64_t pIndex);
	bool isMarked(uint64_t pIndex) const;
	Event<N> getEvent(uint64_t pIndex) const;
	uint64_t memSize() const;
	uint64_t diskSize() const;
protected:
	/*
	 * assorted vectors holding the result of enumeration on smaller
	 * parts of the key: probability, candidate key labels and flag
	 * used for reduction rule
	 */
	size_t mEventTypeSize;
	size_t mSize;
	size_t mBaseLimit;
	vector<bool> mUsed;
	vector<pair<double, array<unsigned char, N>>> mEventMemory;

	// cache / file structures
	const uint64_t mCacheSize, mCacheMask;
	// last enumerated event
	vector<pair<double, array<unsigned char, N>>> mLastEvents;
	mutable unordered_map<uint64_t, pair<uint64_t, vector<pair<double, array<unsigned char, N>>>>> mCache;
	mutable fstream mEventStream;

	string fileName() const;
	void openFile() const;
	void extendCache();
	pair<uint64_t, vector<pair<double, array<unsigned char, N>>>>& loadCache(uint64_t highIndex) const;
};

#include "EventListHddDefs.h"

#endif
#endif /* EVENTLIST_H_ */
