/*
 * EventListRamDefs.h
 *
 *  Created on: Mar 29, 2012
 *      Author: nicolaq
 */

#ifndef EVENTLISTRAMDEFS_H_
#define EVENTLISTRAMDEFS_H_

template<unsigned N>
EventList<N>::EventList() {
}

template<unsigned N>
EventList<N>::~EventList() {
}

template<unsigned N>
void EventList<N>::insert(
		const pair<double, array<unsigned char, N>>& pEvent) {
	mUsed.push_back(false);
	mEventMemory.push_back(pEvent);
}

template<unsigned N>
uint64_t EventList<N>::size() const {
	return mEventMemory.size();
}

template<unsigned N>
void EventList<N>::setMark(uint64_t pIndex) {
	mUsed[pIndex] = true;
}

template<unsigned N>
void EventList<N>::clearMark(uint64_t pIndex) {
	mUsed[pIndex] = false;
}

template<unsigned N>
bool EventList<N>::isMarked(uint64_t pIndex) const {
	return mUsed[pIndex];
}

template<unsigned N>
Event<N> EventList<N>::getEvent(uint64_t pIndex) const {
	return Event<N>(pIndex, mEventMemory[pIndex]);
}

template<unsigned N>
uint64_t EventList<N>::memSize() const {
	uint64_t sizeValue = sizeof(*this);
	sizeValue += mEventMemory.size() * sizeof(pair<double, array<unsigned char, N>>);
	sizeValue += (mUsed.size() + 7) >> 3;
	return sizeValue;
}

template<unsigned N>
uint64_t EventList<N>::diskSize() const {
	return 0;
}

#endif /* EVENTLISTRAMDEFS_H_ */
