/*
 * ParallelEnumeration.cpp
 *
 *  Created on: Apr 4, 2012
 *      Author: nicolaq
 */

#include<iostream>
#include"ParallelEnumeration.h"
/*
pair<double, uint64_t> splitEntropy(const DistributionType& pDistribution) {
	double entropy = 0;
	uint64_t index = 0, maxIndex = 0;
	for(auto& v0 : pDistribution) {
		double subkeyEntropy = accumulate(v0.begin(), v0.end(), 0.0,
				[] (double acc, pair<unsigned char, double> proba) {return acc - proba.second * log(proba.second);
				});
		if(subkeyEntropy > entropy) {
			maxIndex = index;
			entropy = subkeyEntropy;
		}
		index++;
	}
	return make_pair(entropy, maxIndex);
}

pair<double, DistributionType> split(const DistributionType& pDistribution,
		bool pLeft) {
	uint64_t splitIndex = splitEntropy(pDistribution).second;
	DistributionType distribution;
	for (unsigned i0 = 0; i0 < pDistribution.size(); ++i0)
		if (i0 != splitIndex)
			distribution[i0] = pDistribution[i0];
		else {
			auto subDistribution = pDistribution[i0];
			sort(subDistribution.begin(), subDistribution.end(),
					[subDistribution](pair<unsigned char, double> v1, pair<unsigned char, double> v2) {return v1.second > v2.second;});
			for (unsigned i1 = 0; i1 < subDistribution.size(); ++i1)
				if ((i1 & 0x1) ^ pLeft)
					distribution[i0].push_back(subDistribution[i1]);
		}
return {	-splitEntropy(distribution).first, distribution};
}

multimap<double, DistributionType> splitDistribution(
		const DistributionType& pDistribution, uint64_t numSplit) {
	multimap<double, DistributionType> splitMap;
	splitMap.insert( {-splitEntropy(pDistribution).first, pDistribution});
	for (uint64_t i0 = 1; i0 < numSplit; ++i0) {
		auto nextSplit = splitMap.begin()->second;
		splitMap.erase(splitMap.begin());
		splitMap.insert(split(nextSplit, true));
		splitMap.insert(split(nextSplit, false));
	}
	return splitMap;
}

array<vector<pair<unsigned char, double>>, 0x10> indexDistribution(const array<vector<double> , 0x10>& pDistribution) {
	array<vector<pair<unsigned char, double>> , 0x10> distribution;
	for(uint64_t i0 = 0; i0 < 0x10; ++i0)
	for(uint64_t i1 = 0; i1 < 0x100; ++i1)
	distribution[i0].push_back( {(unsigned char)i1, pDistribution[i0][i1]});
	return distribution;
}

ParallelEnumeration::ParallelEnumeration(
		const array<vector<double> , 0x10>& pDistribution,
		uint64_t pNumThreads, uint64_t pNumSplit, uint64_t pUnitSize,
		uint64_t pThreadDelay) :
	mRun(true), mUnitSize(pUnitSize), mThreadDelay(pThreadDelay), mBufferFirst(
			0), mBufferLast(0), mBufferSize(0x10000), mBufferMask(0xffff),
			mBuffer(mBufferSize), mQueue(1), mQueueReserve(pNumSplit, 0),
			mEnumLocks(pNumSplit) {
auto splitMap = splitDistribution(indexDistribution(pDistribution), pNumSplit);
for(auto& v0 : splitMap)
mSplitEnums.push_back(unique_ptr<Enumeration<0x10>>(new Enumeration<0x10>(v0.second)));

// create threads and put them to work
for (unsigned i0 = 0; i0 < pNumThreads; ++i0)
mThreads.push_back(thread {&ParallelEnumeration::doThread, this});
}

ParallelEnumeration::~ParallelEnumeration() {
	// tell threads to die and wait for them to do it
	mRun = false;
for(auto& v0: mThreads)
v0.join();
}

pair<double, array<unsigned char, 0x10> > ParallelEnumeration::nextCandidate() {
	while (true) {
		// read from the cyclic buffer if possible
		//unique_lock<mutex> bufferLock(mBufferMutex);
		if (mBufferFirst - mBufferLast) {
			auto extracted = mBuffer[mBufferFirst & mBufferMask];
			++mBufferFirst;
			return extracted;
		}
		//bufferLock.unlock();
		// else work as a thread
		static unsigned index = 0;
		cout << '.';
		cout.flush();
		if((++index & 0xff) == 0)
			cout << endl;
		fillQueue();
	}
}

uint64_t ParallelEnumeration::memSize() const {
	uint64_t sizeValue = 0;
	for(auto& v0 : mSplitEnums)
	sizeValue += v0->memSize();
	sizeValue += sizeof(*this);
	sizeValue += mBuffer.size() * sizeof(pair<double, array<unsigned char, 0x10>>);
	sizeValue += mQueue.size() * sizeof(HeapElement);
	sizeValue += mQueueReserve.size() * sizeof(uint64_t);
	sizeValue += mEnumLocks.size() * sizeof(mutex);
	sizeValue += mSplitEnums.size() * sizeof(Enumeration<0x10>*);
	return sizeValue;
}

uint64_t ParallelEnumeration::diskSize() const {
	uint64_t sizeValue = 0;
	for(auto& v0 : mSplitEnums)
	sizeValue += v0->diskSize();
	return sizeValue;
}

void ParallelEnumeration::doThread() {
	cout.sync_with_stdio(true);
	while (mRun) {
		bool worked = fillQueue();
		worked |= readQueue();
		if (!worked) {
			// if filling the heap is impossible, wait some time
			chrono::milliseconds delay(mThreadDelay);
			this_thread::sleep_for(delay);
		}
	}
}

bool ParallelEnumeration::readQueue() {
	unique_lock<mutex> heapLock(mQueueMutex, try_to_lock_t());
	//unique_lock<mutex> bufferLock(mBufferMutex);
	if (!heapLock.owns_lock() || (*min_element(mQueueReserve.begin(),
			mQueueReserve.end()) == 0) || (mBufferLast - mBufferFirst
			- mBufferSize == 0))
		return false;
	while (true) {
		auto extracted = popQueue();
		//		cout << " Write " << mBufferFirst << ' ' <<  mBufferLast << ' ' << extracted.mProbability << endl;
		mBuffer[mBufferLast & mBufferMask] = {extracted.mProbability, extracted.mKey};
		++mBufferLast;
		if ((--mQueueReserve[extracted.mEnum] == 0) || (mBufferLast
				- mBufferFirst - mBufferSize == 0))
			return true;
	}
}

bool ParallelEnumeration::fillQueue() {
	for (unsigned i0 = 0; i0 < mSplitEnums.size(); i0++) {
		if (mQueueReserve[i0] < mUnitSize) {
			unique_lock<mutex> enumLock(mEnumLocks[i0], try_to_lock_t());
			if (enumLock.owns_lock()) {
				vector<HeapElement> enumBatch;
				for (unsigned i1 = 0; i1 < mUnitSize; i1++) {
auto				candidate = mSplitEnums[i0]->nextCandidate();
				enumBatch.push_back( {i0, candidate.first, candidate.second});
			}
			unique_lock<mutex> heapLock(mQueueMutex);
			pushQueue(enumBatch);
			mQueueReserve[i0] += mUnitSize;
			return true;
		}
	}
}
return false;
}

HeapElement ParallelEnumeration::popQueue() {
	HeapElement extracted = move(mQueue[1]);
	mQueue[1] = move(mQueue.back());
	mQueue.pop_back();
	maxHeap(1);
	return extracted;
}

void ParallelEnumeration::pushQueue(const vector<HeapElement>& pElements) {
	mQueue.insert(mQueue.end(), pElements.begin(), pElements.end());
	for (unsigned i0 = mQueue.size() - pElements.size(); i0 < mQueue.size(); i0++) {
		uint64_t index = i0;
		while (index > 1 && mQueue[index >> 1].mProbability
				< mQueue[index].mProbability) {
			swap(mQueue[index >> 1], mQueue[index]);
			index >>= 1;
		}
	}
}

void ParallelEnumeration::maxHeap(uint64_t index) {
	uint64_t largest = index;
	uint64_t child = index << 1;
	if (child < mQueue.size() && mQueue[largest].mProbability
			< mQueue[child].mProbability)
		largest = child;
	++child;
	if (child < mQueue.size() && mQueue[largest].mProbability
			< mQueue[child].mProbability)
		largest = child;
	if (largest != index) {
		swap(mQueue[largest], mQueue[index]);
		maxHeap(largest);
	}
}
*/
