/*
 * ThreadEnumeration.h
 *
 *  Created on: Apr 10, 2012
 *      Author: nicolaq
 */

#ifndef THREADENUMERATION_H_
#define THREADENUMERATION_H_

#include"Includes.h"
#include<thread>
#include<atomic>
#include<mutex>
#include"Enumeration.h"

typedef pair<double, array<unsigned char, 0x10> > Candidate;

typedef pair<uint64_t, Candidate> HeapElement;

class ThreadEnumeration {
public:
	ThreadEnumeration(const array<vector<double> , 0x10>& pDistribution,
			uint64_t pNumThreads, uint64_t pNumSplit, uint64_t pBufferSize);
	virtual ~ThreadEnumeration();

	pair<double, array<unsigned char, 0x10> > nextCandidate();

	uint64_t memSize() const;
	uint64_t diskSize() const;
protected:
	void doThread();
	bool fillSplitBuffer();
	bool fillBuffer();
	void pushHeap(uint64_t pSplit, const Candidate& pCandidate);
	void maxHeap(uint64_t index);

	bool mRun;
	const uint64_t mBufferSize, mBufferMask;
	uint64_t mBufferHead, mBufferTail;
	vector<Candidate> mBuffer;

	mutex mHeapLock;
	vector<HeapElement> mHeap;

	vector<uint64_t> mSplitBufferHead, mSplitBufferTail;
	vector<vector<Candidate> > mSplitBuffer;


	vector<mutex> mEnumLocks;
	vector<unique_ptr<Enumeration<0x10> > > mSplitEnums;

	const chrono::microseconds mThreadDelay;
	vector<thread> mThreads;
};

#endif /* THREADENUMERATION_H_ */
