/*
 * ThreadRank.h
 *
 *  Created on: Apr 12, 2012
 *      Author: nicolaq
 */

#ifndef THREADRANK_H_
#define THREADRANK_H_

#include"Includes.h"
#include<thread>
#include<atomic>
#include<mutex>
#include"Enumeration.h"

typedef pair<double, array<unsigned char, 0x10> > Candidate;

typedef pair<uint64_t, Candidate> HeapElement;

class ThreadRank{
public:
	ThreadRank(const array<vector<double> , 0x10>& pDistribution,
			uint64_t pNumThreads, uint64_t pNumSplit);
	virtual ~ThreadRank();

	uint64_t findRank(double keyProbability);
	Candidate findKey(function<bool(array<unsigned char, 0x10>)>& pOracle);

	uint64_t memSize() const;
	uint64_t diskSize() const;
protected:
	void doWork();
	bool doSomeWork();

	uint64_t mUnitSize;
	bool mAttack;
	bool mFound;
	vector<double> mLastProbabilities;
	vector<uint64_t> mRank;
	Candidate mCandidate;
	double mTargetProbability;
	function<bool(array<unsigned char, 0x10>)> mOracle;

	uint64_t mNumThreads;
	vector<mutex> mEnumLocks;
	vector<unique_ptr<Enumeration<0x10> > > mSplitEnums;

	vector<thread> mThreads;
};

#endif /* THREADRANK_H_ */
