/*
 * KeyTope.h
 *
 *  Created on: May 14, 2012
 *      Author: nicolaq
 */

#ifndef KEYTOPE_H_
#define KEYTOPE_H_

#include"Includes.h"
typedef __uint128_t uint128;

class KeyTope {
public:
	KeyTope(const vector<vector<double>>& pDistribution = vector<vector<double>>());
	KeyTope(const vector<unsigned>& pTop, const vector<unsigned>& pBot);
	virtual ~KeyTope();

	KeyTope splitLargest();
	KeyTope splitSmallest();

	uint128 carvePiece(function<int(const vector<unsigned>&)> pFunc, const array<uint128, 3>& pEstimation);
	bool isCarved() const;
	int carvedSign() const;
	uint128 volume() const;

	bool operator()(const KeyTope& pTope1, const KeyTope& pTope2) const;
protected:
	void computeVolume();

	vector<unsigned> mTopCorner;
	vector<unsigned> mBotCorner;

	bool mCarved;
	int mCarvedSign;
	bool mCarvedInside;
	vector<unsigned> mCarvePoint;

	uint128 mVolume;
	uint128 mCarvedVolume;
};

#endif /* KEYTOPE_H_ */
