/*
 * TopeQueue.cpp
 *
 *  Created on: Jun 6, 2012
 *      Author: nicolaq
 */

#include "TopeQueue.h"

TopeQueue::TopeQueue() :
		mReduced(true), mQueue(1), mSize(0) {
}

TopeQueue::~TopeQueue() {
}

void TopeQueue::push(const KeyTope& pTope) {
	if (mReduced) {
		uint64_t index = mQueue.size();
		mQueue.push_back(pTope);
		while (index > 1 && mQueue[index >> 1].volume() < mQueue[index].volume()) {
			swap(mQueue[index >> 1], mQueue[index]);
			index >>= 1;
		}
	} else {
		mQueue[1] = pTope;
		maxHeap(1);
		mReduced = true;
	}
	++mSize;
}

KeyTope TopeQueue::pop() {
	if (!mReduced) {
		mQueue[1] = mQueue.back();
		mQueue.pop_back();
		maxHeap(1);
	}
	KeyTope extracted = mQueue[1];
	mReduced = false;
	--mSize;
	return extracted;
}

bool TopeQueue::empty() const {
	return mSize == 0;
}

unsigned TopeQueue::size() const {
	return mSize;
}

//__uint128_t TopeQueue::truncate() {
//	__uint128_t truncVolume = mQueue.back().volume();
//	mQueue.pop_back();
//	return truncVolume;
//}

void TopeQueue::maxHeap(uint64_t index) {
	uint64_t largest = index;
	uint64_t child = index << 1;
	if (child < mQueue.size() && mQueue[largest].volume()
			< mQueue[child].volume())
		largest = child;
	++child;
	if (child < mQueue.size() && mQueue[largest].volume()
			< mQueue[child].volume())
		largest = child;
	if (largest != index) {
		swap(mQueue[largest], mQueue[index]);
		maxHeap(largest);
	}
}
